import type { EnumTypeDefinitionNode, FieldDefinitionNode, GraphQLSchema, InputObjectTypeDefinitionNode, InputValueDefinitionNode, InterfaceTypeDefinitionNode, ObjectTypeDefinitionNode, UnionTypeDefinitionNode } from 'graphql';
import type { ValidationSchemaPluginConfig } from '../config';
import { BaseSchemaVisitor } from '../schema_visitor';
import type { Visitor } from '../visitor';
export declare class ValibotSchemaVisitor extends BaseSchemaVisitor {
    constructor(schema: GraphQLSchema, config: ValidationSchemaPluginConfig);
    importValidationSchema(): string;
    initialEmit(): string;
    get InputObjectTypeDefinition(): {
        leave: (node: InputObjectTypeDefinitionNode) => string;
    };
    get InterfaceTypeDefinition(): {
        leave: ((node: InterfaceTypeDefinitionNode) => any) | undefined;
    };
    get ObjectTypeDefinition(): {
        leave: ((node: ObjectTypeDefinitionNode) => any) | undefined;
    };
    get EnumTypeDefinition(): {
        leave: (node: EnumTypeDefinitionNode) => void;
    };
    get UnionTypeDefinition(): {
        leave: (node: UnionTypeDefinitionNode) => string | undefined;
    };
    protected buildInputFields(fields: readonly (FieldDefinitionNode | InputValueDefinitionNode)[], visitor: Visitor, name: string): string;
}
